From de396b9c36039ff73f18b1d267bd34b36b320d31 Mon Sep 17 00:00:00 2001
From: Jiangyi Chen <chenjiangyi@uniontech.com>
Date: Tue, 22 Sep 2020 10:18:27 +0000
Subject: [PATCH] iphlpapi: Avoid local variables overwriting external
 variables. Local variables will affect the flags passed to append_table_row
 and eventually cause problems with the call of RtlReAllocateHeap.

Signed-off-by: Jiangyi Chen <chenjiangyi@uniontech.com>
---
 dlls/iphlpapi/ipstats.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

diff --git a/dlls/iphlpapi/ipstats.c b/dlls/iphlpapi/ipstats.c
index d8c2ce029b..d62b20f614 100644
--- a/dlls/iphlpapi/ipstats.c
+++ b/dlls/iphlpapi/ipstats.c
@@ -1402,7 +1402,7 @@ DWORD WINAPI AllocateAndGetIpForwardTableFromStack(PMIB_IPFORWARDTABLE *ppIpForw
         if ((fp = fopen("/proc/net/route", "r")))
         {
             char buf[512], *ptr;
-            DWORD flags;
+            DWORD rtf_flags;
 
             /* skip header line */
             ptr = fgets(buf, sizeof(buf), fp);
@@ -1417,10 +1417,10 @@ DWORD WINAPI AllocateAndGetIpForwardTableFromStack(PMIB_IPFORWARDTABLE *ppIpForw
 
                 row.dwForwardDest = strtoul(ptr, &ptr, 16);
                 row.dwForwardNextHop = strtoul(ptr + 1, &ptr, 16);
-                flags = strtoul(ptr + 1, &ptr, 16);
+                rtf_flags = strtoul(ptr + 1, &ptr, 16);
 
-                if (!(flags & RTF_UP)) row.u1.ForwardType = MIB_IPROUTE_TYPE_INVALID;
-                else if (flags & RTF_GATEWAY) row.u1.ForwardType = MIB_IPROUTE_TYPE_INDIRECT;
+                if (!(rtf_flags & RTF_UP)) row.u1.ForwardType = MIB_IPROUTE_TYPE_INVALID;
+                else if (rtf_flags & RTF_GATEWAY) row.u1.ForwardType = MIB_IPROUTE_TYPE_INDIRECT;
                 else row.u1.ForwardType = MIB_IPROUTE_TYPE_DIRECT;
 
                 strtoul(ptr + 1, &ptr, 16); /* refcount, skip */
-- 
2.20.1

